#ifdef RCSID
static char RCSid[] =
"$Header: d:/cvsroot/tads/TADS2/RUNSTAT.C,v 1.1.1.1 1999/05/09 21:32:56 MJRoberts Exp $";
#endif

/* Copyright (c) 1992 by Michael J. Roberts.  All Rights Reserved. */
/*
Name
  runstat.c - tads 1 compatible runstat()
Function
  generates status line
Notes
  none
Modified
  04/04/92 MJRoberts     - creation
*/

#include "os.h"
#include "std.h"
#include "mcm.h"
#include "obj.h"
#include "run.h"
#include "tio.h"
#include "voc.h"
#include "dat.h"

static runcxdef *runctx;
static voccxdef *vocctx;
static tiocxdef *tioctx;

void runstat(int flag)
{
    objnum  locobj;
    runsdef val;
    int     savemoremode;
    
    runppr(runctx, vocctx->voccxme, PRP_LOCATION, 0);
    if (runtostyp(runctx) != DAT_OBJECT)
    {
        rundisc(runctx);
        return;
    }
    locobj = runpopobj(runctx);
    
    os_status(1);
    savemoremode = setmore(0);
    
    if (flag)
    {
        runpush(runctx, DAT_TRUE, &val);
        runppr(runctx, locobj, PRP_LOOKAROUND, 1);
    }
    else
        runppr(runctx, locobj, PRP_STATUSLINE, 0);

    /* if we're in the status line, make sure the line gets flushed */
    if (os_get_status() != 0)
        tioputs(tioctx, "\\n");
    outflushn(0);

    setmore(savemoremode);
    os_status(0);
}

void runistat(voccxdef *vctx, runcxdef *rctx, tiocxdef *tctx)
{
    runctx = rctx;
    vocctx = vctx;
    tioctx = tctx;
}

