#ifndef _RTPREFS_
#define _RTPREFS_

/*
 * rtprefs -
 *
 * Handle preferences for the runtime.  These functions are common
 * to both the runtime and the debugger.
 */
 
#include <Types.h>

void RTPGetFontName(StringPtr name);
short RTPGetFontID();
short RTPGetFontSize();
void RTPGetWindowSize(Rect& r);

void RTPSetFont(ConstStr255Param fontName);
void RTPSetFontSize(short size);
void RTPSetWindowUserSize(const Rect& r);
void RTPSetWindowStandardSize(const Rect& r);


/*
 * Functions to explicitly load or save the preferences to a file.
 * These are called automatically by RTPGet* and RTPSet*, but are
 * provided for completeness.
 */
OSErr RTPLoad();
	// Load the preferences from the preferences file.  If it doesn't
	// exist, create it with the default preferences.

OSErr RTPSave();
	// Save the preferences back to the preferences file.


#endif
