#ifdef RCSID
static char RCSid[] =
"$Header: d:/cvsroot/tads/TADS2/msdos/ossdos32.c,v 1.1.1.1 1999/05/09 21:33:08 MJRoberts Exp $";
#endif

/* Copyright (c) 1997 by Michael J. Roberts.  All Rights Reserved. */
/*
Name
  ossdos32.c - ossdos functions for win32
Function
  
Notes
  
Modified
  11/22/97 MJRoberts  - Creation
*/

#include <windows.h>
#include <wincon.h>
#include <string.h>

/*
 *   Console output buffer handle 
 */
HANDLE g_out_bufhdl;

/* screen width */
static int s_scrwid;

void ossscu(int top, int left, int bottom, int right, int blankcolor)
{
    COORD newpos;
    SMALL_RECT pos;
    SMALL_RECT clip;
    CHAR_INFO fill;

    pos.Top = clip.Top = top;
    pos.Left = clip.Left = left;
    pos.Bottom = clip.Bottom = bottom;
    pos.Right = clip.Right = right;

    newpos.X = left;
    newpos.Y = top + 1;

    fill.Char.AsciiChar = ' ';
    fill.Attributes = blankcolor;

    ScrollConsoleScreenBuffer(g_out_bufhdl, &pos, &clip, newpos, &fill);
}

void ossscr(int top, int left, int bottom, int right, int blankcolor)
{
    COORD newpos;
    SMALL_RECT pos;
    SMALL_RECT clip;
    CHAR_INFO fill;

    pos.Top = clip.Top = top;
    pos.Left = clip.Left = left;
    pos.Bottom = clip.Bottom = bottom;
    pos.Right = clip.Right = right;

    newpos.X = left;
    newpos.Y = top - 1;

    fill.Char.AsciiChar = ' ';
    fill.Attributes = blankcolor;

    ScrollConsoleScreenBuffer(g_out_bufhdl, &pos, &clip, newpos, &fill);
}

void ossclr(int top, int left, int bottom, int right, int color)
{
    int curline;
    DWORD line_len;

    /* calculate the length of each line that we'll write */
    line_len = right - left + 1;

    /* write each line */
    for (curline = top ; curline <= bottom ; ++curline)
    {
        COORD pos;
        DWORD actual;

        pos.X = left;
        pos.Y = curline;
        FillConsoleOutputAttribute(g_out_bufhdl, (WORD)color, line_len,
                                   pos, &actual);
        FillConsoleOutputCharacter(g_out_bufhdl, ' ', line_len,
                                   pos, &actual);
    }
}

void ossloc(int line, int column)
{
    COORD pos;

    pos.X = column;
    pos.Y = line;
    SetConsoleCursorPosition(g_out_bufhdl, pos);
}

int ossmon(void)
{
    return 0;
}

void ossdsp(int line, int column, int color, const char *msg)
{
    COORD pos;
    DWORD nwritten;

    pos.X = column;
    pos.Y = line;
    SetConsoleTextAttribute(g_out_bufhdl, (WORD)color);
    SetConsoleCursorPosition(g_out_bufhdl, pos);
    WriteConsole(g_out_bufhdl, msg, strlen(msg), &nwritten, 0);
}

void ossgmx(int *max_linep, int *max_columnp)
{
    CONSOLE_SCREEN_BUFFER_INFO info;
    DWORD console_mode;

    /* get the console handle */
    g_out_bufhdl = GetStdHandle(STD_OUTPUT_HANDLE);

    /* 
     *   turn off wrapping when writing at the end of the line - the
     *   automatic wrapping screws up our scrolling, and we don't need it
     *   anyway since we keep track of all of our cursor positioning
     *   ourselves, hence it's easier if we just turn this feature off 
     */
    GetConsoleMode(g_out_bufhdl, &console_mode);
    SetConsoleMode(g_out_bufhdl,
                   console_mode & ~(ENABLE_WRAP_AT_EOL_OUTPUT
                                    | ENABLE_PROCESSED_OUTPUT));
    
    /* get the size of the screen and return it to the caller's variables */
    GetConsoleScreenBufferInfo(g_out_bufhdl, &info);
    *max_columnp = info.dwMaximumWindowSize.X - 1;
    *max_linep = info.dwMaximumWindowSize.Y - 1;

    /* note the screen width for our own use */
    s_scrwid = info.dwMaximumWindowSize.X;
}
